#-*- coding: utf-8 -*- 
#(for potential non-ASCII encoding)
###This Version of TAALES introduces threading, which allows the GUI to operate normally.
###One side effect is that the program is slightly slowed down...


from __future__ import division
import Tkinter as tk
import tkFont
import tkFileDialog
import Tkconstants
import os
import re
import sys 
###THIS IS NEW IN V1.3.py ###
from threading import Thread
import Queue

#This creates a que in which the core TAALES program can communicate with the GUI
dataQueue = Queue.Queue()

#This creates the message for the progress box (and puts it in the dataQueue)
progress = "...Waiting for Data to Process"
dataQueue.put(progress)

#This creates a function for starting a new thread. The arguments are what TAALES needs to run
#Def1 is the core TAALES program
def start_thread(def1, arg1, arg2, arg3):
	t = Thread(target=def1, args=(arg1, arg2, arg3))
	t.start()
	
###END NEW for 1.3 Section (Though see below for other changes)###
	
#This is the solution on a mac... this is how the correct path is given for program files.
def resource_path(relative):
    if hasattr(sys, "_MEIPASS"):
        return os.path.join(sys._MEIPASS, relative)
    return os.path.join(relative)
    
class MyApp:
	def __init__(self, parent):
		
		#Creates font styles - Task: Make these pretty!
		helv14= tkFont.Font(family= "Helvetica", size=14)
		times14= tkFont.Font(family= "Times", size=14)
		helv16= tkFont.Font(family= "Helvetica", size = 16, weight = "bold", slant = "italic")
		
		#This defines the GUI parent (ish)
		self.myParent = parent
		
		#This creates the header text - Task:work with this to make more pretty!
		self.spacer1= tk.Label(parent, text= "Tool for the Automatic Analysis of Lexical Sophistication", font = helv16, background = "#BFEAA3")
		self.spacer1.pack()
		
		#This creates a frame for the meat of the GUI
		self.thestuff= tk.Frame(parent, background ="#BFEAA3")
		self.thestuff.pack()
		#Currently, the sizes aren't doing anything...

		#Within the 'thestuff' frame, this creates a frame on the left for the buttons/input
		self.myContainer1 = tk.Frame(self.thestuff, background = "#BFEAA3")
		self.myContainer1.pack(side = tk.LEFT, expand = tk.TRUE)


		#Creates next space
		self.button2spacer= tk.Label(self.myContainer1, text= "\n", background = "#BFEAA3")
		self.button2spacer.pack()

		
		#This creates the container for the stuff on the right (instructions, updates, etc.)
		self.myContainer1= tk.Frame(self.thestuff, background = "#BFEAA3")
		self.myContainer1.pack(side = tk.RIGHT, expand= tk.TRUE)

		#This creates a label frame for the stuff on the right (may delete).  It allows for
		#Text to be displayed above the widgets AND for a line to be placed around the elements
		self.labelframe2 = tk.LabelFrame(self.myContainer1, text= "Instructions", background = "#BFEAA3")
		self.labelframe2.pack(expand=tk.TRUE)

		#This creates the list of instructions.  There may be a better way to do this...
		self.instruct = tk.Label(self.labelframe2, height = "10", width = "45", justify = tk.LEFT, padx = "4", pady= "6", anchor = tk.W, font = helv14, text ="To process your files, please follow these steps: \n\n1. Choose the input folder (where your files are).\n\n2. Select the folder you want the output file to go in.\n\n3. Give a name to the output file.\n\n4. Press the 'Process Texts' button." )
		self.instruct.pack()
		
		#spacer after instructions box to make it pretty
		self.spacer1 = tk.Label(self.myContainer1, text= "\n", background = "#BFEAA3")
		self.spacer1.pack()
		
		#Creates Label Frame for Data Input area
		self.secondframe= tk.LabelFrame(self.myContainer1, text= "Data Input", background = "#BFEAA3")
		self.secondframe.pack(expand=tk.TRUE) 
		#This Places the first button under the instructions.
		self.button1 = tk.Button(self.secondframe)
		self.button1.configure(text= "Select Input Folder")
		self.button1.pack()
		
		#This tells the button what to do when clicked.  Currently, only a left-click
		#makes the button do anything (e.g. <Button-1>). The second argument is a "def"
		#That is defined later in the program.
		self.button1.bind("<Button-1>", self.button1Click)
		
		#Creates default dirname so if statement in Process Texts can check to see
		#if a directory name has been chosen
		self.dirname = ""
		
		#This creates a label for the first program input (Input Directory)
		self.inputdirlabel =tk.LabelFrame(self.secondframe, height = "1", width= "45", padx = "4", text = "Your selected input folder:", background = "#BFEAA3")
		self.inputdirlabel.pack()
		
		#Creates label that informs user which directory has been chosen
		directoryprompt = "(No Folder Chosen)"
		self.inputdirchosen = tk.Label(self.inputdirlabel, height= "1", width= "44", justify=tk.LEFT, padx = "4", anchor = tk.W, font= helv14, text = directoryprompt)
		self.inputdirchosen.pack()
		
		#This creates the Output Directory button.
		self.button2 = tk.Button(self.secondframe)
		self.button2["text"]= "Select Output Folder"
		#This tells the button what to do if clicked.
		self.button2.bind("<Button-1>", self.button2Click)
		self.button2.pack()
		self.outdirname = ""
		
		#Creates a label for the second program input (Output Directory)
		self.outputdirlabel = tk.LabelFrame(self.secondframe, height = "1", width= "45", padx = "4", text = "Your selected output folder:", background = "#BFEAA3")
		self.outputdirlabel.pack()
		
		#Creates a label that informs sure which directory has been chosen
		outdirectoryprompt = "(No output Folder Chosen)"
		self.outputdirchosen = tk.Label(self.outputdirlabel, height= "1", width= "44", justify=tk.LEFT, padx = "4", anchor = tk.W, font= helv14, text = outdirectoryprompt)
		self.outputdirchosen.pack()
		
		self.myContainer2 = tk.Frame(self.secondframe)
		self.myContainer2.pack()
		
		#Creates label for filename entrybox
		self.entry1label= tk.LabelFrame(self.myContainer2, text= "type name of output file:", background = "#BFEAA3")
		self.entry1label.pack()

		#Creates frame so entry 1 and button can be side-by-side
		self.outfileframetop= tk.Frame(self.entry1label)
		self.outfileframetop.pack()
		
		#Creates filename entrybox
		self.entry1 = tk.Entry(self.outfileframetop)
		self.entry1.insert(tk.INSERT, "results")
		
		#Tells entrybox what to do when user presses "return"
		self.entry1.bind("<Return>", self.entry1Return)
		self.entry1.pack(side = tk.LEFT)
		
		#Creates Default Value for filename
		self.input2 = ""
		
		self.SubmitFilenameButton = tk.Button(self.outfileframetop)
		self.SubmitFilenameButton.configure(text = "Submit Filename")
		self.SubmitFilenameButton.pack(side = tk.RIGHT)
		self.SubmitFilenameButton.bind("<Button-1>", self.SubmitFilenameButtonClick)
		
		self.outfileframe = tk.Frame(self.entry1label)
		self.outfileframe.pack()
		
		#Label for the filename entry output
		self.filechosenlabel = tk.LabelFrame(self.outfileframe, height = "1", width= "45", padx = "4", text = "Your output filename:", background = "#BFEAA3")
		self.filechosenlabel.pack(side = tk.BOTTOM)
		
		#Creates a label that informs user the current output filename
		outdirectoryprompt = "results.csv (default)"
		self.filechosenchosen = tk.Label(self.filechosenlabel, height= "1", width= "44", justify=tk.LEFT, padx = "4", anchor = tk.W, font= helv14, text = outdirectoryprompt)
		self.filechosenchosen.pack()
		
		#self.text1 = Text(self.labelframe2, height = "14", width = "55", padx = "5", pady = "5")
		#self.text1.insert(INSERT, "To process your files, please follow these steps: \n\n1. Choose the input directory where your files are.\n\n2. Select the folder you want the output file to go.\n\n3. Give a name to the output file.\n\n4. Press the 'Process Texts' button.\n\n")
		#self.text1.pack()

		self.space3 = tk.Label(self.myContainer1, text = "\n", background = "#BFEAA3")
		self.space3.pack()
		
		self.BottomSpace= tk.LabelFrame(self.myContainer1, text = "Run Program", background = "#BFEAA3")
		self.BottomSpace.pack()

		self.button3= tk.Button(self.BottomSpace)
		self.button3["text"] = "Process Texts"
		self.button3.bind("<Button-1>", self.runprogram)
		self.button3.pack()
		
		#self.spacer2 = Label(self.BottomSpace, text="\n", background = "#BFEAA3")
		#self.spacer2.pack()

		self.progresslabelframe = tk.LabelFrame(self.BottomSpace, text= "Program Status", background = "#BFEAA3")
		self.progresslabelframe.pack(expand= tk.TRUE)
		
		#progress = "...Waiting for Data to Process"
		self.progress= tk.Label(self.progresslabelframe, height= "1", width= "45", justify=tk.LEFT, padx = "4", anchor = tk.W, font= helv14, text=progress)
		self.progress.pack()
		
		self.poll(self.progress)
		
	def entry1Return(self,event):
		input= self.entry1.get()
		self.input2 = input + ".csv"
		self.filechosenchosen.config(text = self.input2)
		self.filechosenchosen.update_idletasks()
	
	#Following is an example of how we can update the information from users...
	def button1Click(self, event):
		#import Tkinter, 
		import tkFileDialog
		self.dirname = tkFileDialog.askdirectory(parent=root,initialdir="/",title='Please select a directory')
		self.displayinputtext = '.../'+self.dirname.split('/')[-1]
		self.inputdirchosen.config(text = self.displayinputtext)
		
		#newmsg= "Chosen"
		#self.inputdirchosen.config(text = newmsg)
		#self.inputdirchosen.update_idletasks()

	def button2Click(self, event):
		self.outdirname = tkFileDialog.askdirectory(parent=root,initialdir="/",title='Please select a directory')
		self.displayoutputtext = '.../' + self.outdirname.split('/')[-1]
		self.outputdirchosen.config(text = self.displayoutputtext)
		
		#outdirmsg= "Chosen"
		#self.outputdirchosen.config(text = outdirmsg)
		#self.outputdirchosen.update_idletasks()
	
	def SubmitFilenameButtonClick(self, event):
		input= self.entry1.get()
		self.input2 = input + ".csv"
		self.filechosenchosen.config(text = self.input2)
		
	def runprogram(self, event):
		self.poll(self.progress)
		start_thread(main, self.dirname, self.outdirname, self.input2)

	def poll(self, function):
		
		self.myParent.after(10, self.poll, function)
		try:
			function.config(text = dataQueue.get(block=False))
			
			#root.update_idletasks()
		except Queue.Empty:
			pass

def main(indir, outdir, outfile):		
	import tkMessageBox
	if indir is "":
		tkMessageBox.showinfo("Supply Information", "Choose Input Directory")
	if outdir is "":
		tkMessageBox.showinfo("Choose Output Directory", "Choose Output Directory")
	if indir is not "" and outdir is not "":
	
		dataQueue.put("Starting TAALES...")
		#TALES: Kristopher Kyle & Scott Crossley: 1/2014
		#Reads any number of files, lemmatizes them (including
		#deleting commas and end-sentence punctuation), and produces two mean scores for each
		#included MRC measure (one for all words and one for content words).  Mean Scores are
		#calculated based on the total MRC score divided by the number of words given an MRC
		#score.

		#put files to process in the "files to process" folder

		#results will be in the "results" folder (it might be a good idea to copy this file,
		#move it to a new folder, and then delete the original to ensure later results files
		#are correct.

		#TALES_V.01: MRC, AWL, Kuperman AoA
		#TALES_V.02: Adds SUBTLEXus
		#TALES_V.03: Adds BNC Frequency
		#TALES_V.04: Adds Brysbaert Concreteness
		#TALES_V.05: Adds BNC Ngram indices
		#TALES_V.06: Adds AFL Indices
		#TALES_V.09.1: All indices included. Fix of AFL indices and Fix of MRC Log Indices
		#TAALES_V.09.2: Fixes short text issue with bigrams/trigrams
		#TAALES_V.09.3: Fixes bug with BNC bigrams

		import glob
		import math

		vsn_count = 1e-100
		vsn_sum = 0

		#Creates Results File
		if outfile is "":
			outfile = "results.csv"
		outputfile = (outdir + "/" + outfile)
		outf=file(outputfile, "w")
		outf.write("""Filename,Word Count,BNC Written Freq AW,BNC Written Freq AW Log,BNC Written Freq CW,BNC Written Freq CW Log,BNC Written Freq FW,BNC Written Freq FW Log,BNC Spoken Freq AW,BNC Spoken Freq AW Log,BNC Spoken Freq CW,BNC Spoken Freq CW Log,BNC Spoken Freq FW,BNC Spoken Freq FW Log,Brown Freq AW  ,Brown Freq AW Log,Brown Freq CW,Brown Freq CW Log,Brown Freq FW,Brown Freq FW Log,KF Freq AW,KF Freq AW Log,KF Freq CW,KF Freq CW Log,KF Freq FW,KF Freq FW Log,SUBTLEXus Freq AW,SUBTLEXus Freq AW Log,SUBTLEXus Freq CW,SUBTLEXus Freq CW Log,SUBTLEXus Freq FW,SUBTLEXus Freq FW Log,TL Freq AW,TL Freq AW Log,TL Freq CW,TL Freq CW Log,TL Freq FW,TL Freq FW Log,BNC Written Range AW,BNC Written Range CW,BNC Written Range FW,BNC Spoken Range AW,BNC Spoken Range CW,BNC Spoken Range FW,KF Ncats AW,KF Ncats CW,KF Ncats FW,KF Nsamp AW,KF Nsamp CW,KF Nsamp FW,SUBTLEXus Range AW,SUBTLEXus Range AW Log,SUBTLEXus Range CW,SUBTLEXus Range CW Log,SUBTLEXus Range FW,SUBTLEXus Range FW Log,Word Count for N-grams,Bigram Type Count,Trigram Type Count,BNC Written Bigram Freq Log,BNC Written Bigram Freq Normed (bi),BNC Written Bigram Freq Normed (bi) Log,BNC Written Bigram Freq Normed (word),BNC Written Bigram Freq Normed (word) Log,BNC Written Trigram Freq Log,BNC Written Trigram Freq Normed (tri),BNC Written Trigram Freq Normed (tri) Log,BNC Written Trigram Freq Normed (word),BNC Written Trigram Freq Normed (word) Log,BNC Spoken Bigram Freq Log,BNC Spoken Bigram Normed (bi) Freq,BNC Spoken Bigram Normed (bi) Freq Log,BNC Spoken Bigram Normed (word) Freq Log,BNC Spoken Bigram Normed (word) Freq,BNC Spoken Trigram Freq Log,BNC Spoken Trigram Normed (tri) Freq,BNC Spoken Trigram Normed (tri) Freq Log,BNC Spoken Trigram Normed (word) Freq Log,BNC Spoken Trigram Normed (word) Freq,BNC Written Bigram Proportion,BNC Spoken Bigram Proportion,BNC Written Trigram Proportion,BNC Spoken Trigram Proportion,All AFL Raw,All AFL Normed,Core AFL Raw,Core AFL Normed,Spoken AFL Raw,Spoken AFL Normed,Written AFL Raw,Written AFL Normed,All AWL Raw,All AWL Normed,AWL Sublist 1 Raw,AWL Sublist 1 Normed,AWL Sublist 2 Raw,AWL Sublist 2 Normed,AWL Sublist 3 Raw, AWL Sublist 3 Normed,AWL Sublist 4 Raw,AWL Sublist 4 Normed,AWL Sublist 5 Raw,AWL Sublist 5 Normed,AWL Sublist 6 Raw,AWL Sublist 6 Normed,AWL Sublist 7 Raw,AWL Sublist 7 Normed,AWL Sublist 8 Raw,AWL Sublist 8 Normed,AWL Sublist 9 Raw,AWL Sublist 9 Normed,AWL Sublist 10 Raw,AWL Sublist 10 Normed,Kuperman AoA AW,Kuperman AoA AW Log,Kuperman AoA CW,Kuperman AoA CW Log,Kuperman AoA FW,Kuperman AoA FW Log,Brysbaert Concreteness Unigram AW,Brysbaert Concreteness Unigram CW,Brysbaert Concreteness FW,Brysbaert Concreteness bigrams AW,Brysbaert Concreteness Combined AW,Brysbaert Concreteness Combined CW,Brysbaert Concreteness Combined FW,MRC Concreteness AW,MRC Concreteness CW,MRC Concreteness FW,MRC Familiarity AW,MRC Familiarity CW,MRC Familiarity FW,MRC Imageability AW,MRC Imageability CW,MRC Imageability FW,MRC Meaningfulness AW,MRC Meaningfulness CW,MRC Meaningfulness FW\n""")
	
		#AFL Function:
		def unique_ngrams(text, list):
			Text1 = text
			counter = 0
			for entry in list:
				#This adds a space to the beginning and end of the AFL entry to ensure that only 
				#the entry is matched.  Note that spaces were added to the beginning and end of 
				#Text1 to ensure the first and last elements are not excluded.
				entry = " " + entry + " "
				if len(re.findall(entry, Text1))>0:
					counter+= len(re.findall(entry,Text1))
					#This ensures that overlap does not occur.  Sub is with <removed> instead of
					#"" to ensure no new, artificial matches are created. Spaces are added to 
					#ensure that real matches will still be possible with adjoining words.
					Text1 = re.sub(entry," <removed> ",Text1)
			return counter
		
		#filenames
		inputfile = indir + "/*.txt"
		filenames = glob.glob(inputfile)

		#defines program files
		mrc_list = file(resource_path('MRC_database_simple_final_lower.txt'), 'rU').readlines()
		lemma_list = file(resource_path('e_lemma_lower.txt'), 'rU').readlines()
		stoplist=file(resource_path('functionword_stop_list.txt'), 'rU').read().lower().split()
	
		#AWL Program Files:
		awl_sl_1=file(resource_path('AWL_SL_1.txt'), 'rU').read().split()
		awl_sl_2=file(resource_path('AWL_SL_2.txt'), 'rU').read().split()
		awl_sl_3=file(resource_path('AWL_SL_3.txt'), 'rU').read().split()
		awl_sl_4=file(resource_path('AWL_SL_4.txt'), 'rU').read().split()
		awl_sl_5=file(resource_path('AWL_SL_5.txt'), 'rU').read().split()
		awl_sl_6=file(resource_path('AWL_SL_6.txt'), 'rU').read().split()
		awl_sl_7=file(resource_path('AWL_SL_7.txt'), 'rU').read().split()
		awl_sl_8=file(resource_path('AWL_SL_8.txt'), 'rU').read().split()
		awl_sl_9=file(resource_path('AWL_SL_9.txt'), 'rU').read().split()
		awl_sl_10=file(resource_path('AWL_SL_10.txt'), 'rU').read().split()
	
		#Kuperman et al. AoA Program Files:
		AoA_list= file(resource_path('AoA_Brysbart.txt'), 'rU').readlines()
	
		#SUBTLEXus Program File:
		freq_list = file(resource_path('SUBTLEXUS_lower.txt'), 'rU').readlines()
	
		#defines BNC Program Files
		freq_list_written = file(resource_path('bnc_written.txt'), 'rU').readlines()
		freq_list_spoken = file(resource_path('bnc_spoken.txt'), 'rU').readlines()
	
		#Brysbaert et al. Program Files:
		B_uni_conc= file(resource_path('Concreteness_Brysbaert_Uni.txt'), 'rU').readlines()
		B_bi_conc= file(resource_path('Concreteness_Brysbaert_Bi.txt'), 'rU').readlines()
	
		#creates dictionary for lemma list
		lemma_dict={}
	
		#N-gram program files
		bigram_spoken_list = file(resource_path('s_all_bi_50000.txt'), 'rU').readlines()
		bigram_written_list = file(resource_path('w_all_bi_50000.txt'), 'rU').readlines()
		trigram_spoken_list = file(resource_path('s_all_tri_50000.txt'), 'rU').readlines()
		trigram_written_list = file(resource_path('w_all_tri_50000.txt'), 'rU').readlines()

		#AFL program Files:
		afl_all = file(resource_path("All_AFL.txt"), 'rU').read().split("\n")
		afl_core = file(resource_path("Core_AFL.txt"), 'rU').read().split("\n")
		afl_spoken = file(resource_path("Spoken_AFL.txt"), 'rU').read().split("\n")
		afl_written = file(resource_path("Written_AFL.txt"), 'rU').read().split("\n")
	
		punctuation = (".","!","?",",", ":",";", "'",'"')
	
	
		#Creates lemma dictionary:

		for line in lemma_list:
			#ignores first lines
			if line[0] is '#':
				continue
			#allows use of each line:
			entries=line.split()
			#creates dictionary entry for each word in line:
			for word in entries:
				lemma_dict[word] = entries[0]

		#Empty Dictionaries for MRC Data:
		kf_freq={}
		kf_freq_log={}
		kf_ncats={}
		kf_nsamp={}
		tl_freq={}
		tl_freq_log={}
		brown_freq={}
		brown_freq_log={}
		fam={}
		concreteness={}
		imageability={}
		meaningfulness_colorado={}
		word_type={}

		#Empty Dictionary for B_AoA	
		B_AoA = {}	
			
		#Empty Dictionaries for SUBTLEXus Data:
		freq={}
		cd={}
		freq_log={}
		cd_log={}

		#Empty Dictionaries for BNC Data:
		freq_written={}
		freq_written_log={}
		range_written={}
		freq_spoken={}
		freq_spoken_log={}
		range_spoken={}

		# Empty Dictionaries for Brysbaert et al. Concreteness Ratings
		B_Conc_Uni = {}
		B_Conc_Bi = {}

		#Empty Dictionaries for ngram data:
		spoken_bi={}
		written_bi={}
		spoken_tri={}
		written_tri={}

		spoken_bi_log={}
		written_bi_log={}
		spoken_tri_log={}
		written_tri_log={}

		#Creates a dictionary for MRC with word:score pairings:
		for line in mrc_list:
			if line[0] is '#':
				continue
			entries= line.split('\t')
			kf_freq[entries[0]]=entries[1]
			kf_ncats[entries[0]]=entries[2]
			kf_nsamp[entries[0]]=entries[3]
			tl_freq[entries[0]]=entries[4]
			brown_freq[entries[0]]=entries[5]
			fam[entries[0]]=entries[6]
			concreteness[entries[0]]=entries[7]
			imageability[entries[0]]=entries[8]
			meaningfulness_colorado[entries[0]]=entries[9]
		
			#Log Dictionaries:
			if not entries[1] == '0':
				kf_freq_log[entries[0]]= math.log10(float(entries[1]))
			if not entries[4] == '0':
				tl_freq_log[entries[0]]= math.log10(float(entries[4]))
			if not entries[5] == '0':
				brown_freq_log[entries[0]]=math.log10(float(entries[5]))
			
		#Creates a dictionary for Kuperman et al. AoA with word:score pairings:
		for line in AoA_list:
			if line[0] is '#':
				continue
			entries= line.split('\t')
			B_AoA[entries[0]]=entries[1]
	
		#Creates a dictionary for SUBTLEXuswith word:score pairings:
		for line in freq_list:
			entries= line.split('\t')
			freq[entries[0]]=entries[1]
			cd[entries[0]]=entries[2]
			freq_log[entries[0]]=entries[4]
			cd_log[entries[0]]=entries[6]
	
		#Creates dictionaries for BNC with word:score pairings:
		for line in freq_list_written:
			if line[0] == '#':
				continue
			entries= line.split('\t')
			freq_written[entries[0]]=entries[2]
			range_written[entries[0]]=entries[4]
			if not entries[2] == '0':
				freq_written_log[entries[0]]=math.log10(float(entries[2])*100000) #multiplied by 100,000 to avoid negatives 

		for line in freq_list_spoken:
			if line[0] == '#':
				continue
			entries= line.split('\t')
			freq_spoken[entries[0]]=entries[2]
			range_spoken[entries[0]]=entries[4]
			if not entries[2] == '0':
				freq_spoken_log[entries[0]]=math.log10(float(entries[2])*100000)
	
		#Creates dictionaries for Brysbaert et al. Concreteness Ratings with word:score pairings:
		for line in B_uni_conc:
			if line[0] is '#':
				continue
			entries= line.split('\t')
			B_Conc_Uni[entries[0]]=entries[1]

		for line in B_bi_conc:
			if line[0] is '#':
				continue
			entries= line.split('\t')
			B_Conc_Bi[entries[0]]=entries[1]

		#Creates Dictionaries for N-grams
		for line in bigram_spoken_list:
			entries= line.split('\t')#splits entries on tab
			spoken_bi[entries[0]]=entries[1]#maps first entry to key and second entry to value in dictionary 
			spoken_bi_log[entries[0]]=math.log10(float(entries[1])*10000)
			#print spoken_bi

		for line in bigram_written_list:
			entries= line.split('\t')
			written_bi[entries[0]]=entries[1]
			written_bi_log[entries[0]]=math.log10(float(entries[1])*10000)
			#print written_bi

		for line in trigram_spoken_list:
			entries= line.split('\t')
			spoken_tri[entries[0]]=entries[1]
			spoken_tri_log[entries[0]]=math.log10(float(entries[1])*10000)
			#print spoken_tri

		for line in trigram_written_list:
			entries= line.split('\t')
			written_tri[entries[0]]=entries[1]
			written_tri_log[entries[0]]=math.log10(float(entries[1])*10000)

	
		#Iterates through target files:
		for filename in filenames:
	
			#updates Program Status
			filename1 = ("Processing: " + re.sub(r'.*?(?=[^/]*.txt)', "", filename))
			dataQueue.put(filename1)
			root.update_idletasks()
			text= file(filename, 'rU').read().lower()
			
			#This cleans up problematic characters that were killing the program. 
			text = text.replace(".", "")
			text = text.replace("  ", " ")
		##### THIS IS NEW FOR VERSION .06!!!! :	
			text=text.replace(",","")
		###################################	
			text= text.split()
		
			#Check to make sure target file is not empty:
			nwords2= len(text)
			if nwords2 == 0:
				continue				
		
			#Holder structure for lemmatized text:
			lemma_text=[]
		
			#Holder Structure for "clean_text":
			clean_text = []
		
			#Holder Structure for "AFL_Text":
			AFL_Text = []

		#MRC Counts:
		#Every Word Incidence Count:         
			kf_freq_count=vsn_count
			kf_freq_log_count=vsn_count
			kf_ncats_count=vsn_count
			kf_nsamp_count=vsn_count
			tl_freq_count=vsn_count
			tl_freq_log_count=vsn_count
			brown_freq_count=vsn_count
			brown_freq_log_count=vsn_count
			fam_count=vsn_count
			concreteness_count=vsn_count
			imageability_count=vsn_count
			meaningfulness_colorado_count=vsn_count

		#Content Word Incidence Count:
			kf_freq_content_count=vsn_count
			kf_freq_log_content_count=vsn_count
			kf_ncats_content_count=vsn_count
			kf_nsamp_content_count=vsn_count
			tl_freq_content_count=vsn_count
			tl_freq_log_content_count=vsn_count
			brown_freq_content_count=vsn_count
			brown_freq_log_content_count=vsn_count
			fam_content_count=vsn_count
			concreteness_content_count=vsn_count
			imageability_content_count=vsn_count
			meaningfulness_colorado_content_count=vsn_count

		#Function Word Incidence Count:
			kf_freq_functionw_count=vsn_count
			kf_freq_log_functionw_count=vsn_count
			kf_ncats_functionw_count=vsn_count
			kf_nsamp_functionw_count=vsn_count
			tl_freq_functionw_count=vsn_count
			tl_freq_log_functionw_count=vsn_count
			brown_freq_functionw_count=vsn_count
			brown_freq_log_functionw_count=vsn_count
			fam_functionw_count=vsn_count
			concreteness_functionw_count=vsn_count
			imageability_functionw_count=vsn_count
			meaningfulness_colorado_functionw_count=vsn_count

		#Every Word Index Score Count:
			kf_freq_sum=vsn_sum
			kf_freq_log_sum=vsn_sum
			kf_ncats_sum=vsn_sum
			kf_nsamp_sum=vsn_sum
			tl_freq_sum=vsn_sum
			tl_freq_log_sum=vsn_sum
			brown_freq_sum=vsn_sum
			brown_freq_log_sum=vsn_sum
			fam_sum=vsn_sum
			concreteness_sum=vsn_sum
			imageability_sum=vsn_sum
			meaningfulness_colorado_sum=vsn_sum

		#Content Word Index Score Count:
			kf_freq_content_sum=vsn_sum
			kf_freq_log_content_sum=vsn_sum
			kf_ncats_content_sum=vsn_sum
			kf_nsamp_content_sum=vsn_sum
			tl_freq_content_sum=vsn_sum
			tl_freq_log_content_sum=vsn_sum
			brown_freq_content_sum=vsn_sum
			brown_freq_log_content_sum=vsn_sum
			fam_content_sum=vsn_sum
			concreteness_content_sum=vsn_sum
			imageability_content_sum=vsn_sum
			meaningfulness_colorado_content_sum=vsn_sum

		#Function Word Index Score Count:
			kf_freq_functionw_sum=vsn_sum
			kf_freq_log_functionw_sum=vsn_sum
			kf_ncats_functionw_sum=vsn_sum
			kf_nsamp_functionw_sum=vsn_sum
			tl_freq_functionw_sum=vsn_sum
			tl_freq_log_functionw_sum=vsn_sum
			brown_freq_functionw_sum=vsn_sum
			brown_freq_log_functionw_sum=vsn_sum
			fam_functionw_sum=vsn_sum
			concreteness_functionw_sum=vsn_sum
			imageability_functionw_sum=vsn_sum
			meaningfulness_colorado_functionw_sum=vsn_sum

		#AWL Word Counts:
			awl_sl_1_count = vsn_sum
			awl_sl_2_count = vsn_sum
			awl_sl_3_count = vsn_sum
			awl_sl_4_count = vsn_sum
			awl_sl_5_count = vsn_sum
			awl_sl_6_count = vsn_sum
			awl_sl_7_count = vsn_sum
			awl_sl_8_count = vsn_sum
			awl_sl_9_count = vsn_sum
			awl_sl_10_count = vsn_sum
		
		#Kuperman et al. AoA Counts:
			#Every Word Incidence Count:
			B_AoA_count= vsn_count

			#Content Word Incidence Count:
			B_AoA_content_count= vsn_count	

			#Function Word Incidence Count:
			B_AoA_funct_count= vsn_count

			#Every Word Index Score Count:
			B_AoA_sum= vsn_sum

			#Content Word Index Score Count:
			B_AoA_content_sum= vsn_sum	

			#Function Word Index Score Count:
			B_AoA_funct_sum= vsn_sum				
	
		#SUBTLEXus Counts:
			#Every Word Incidence Count:         
			freq_count=vsn_count
			cd_count=vsn_count
			freq_log_count=vsn_count
			cd_log_count=vsn_count

			#Content Word Incidence Count:
			freq_content_count=vsn_count
			cd_content_count=vsn_count
			freq_log_content_count=vsn_count
			cd_log_content_count=vsn_count

			#Function Word Incidence Count:
			freq_functionw_count=vsn_count
			cd_functionw_count=vsn_count
			freq_log_functionw_count=vsn_count
			cd_log_functionw_count=vsn_count

			#Every Word Index Score Count:
			freq_sum=vsn_sum
			cd_sum=vsn_sum
			freq_log_sum=vsn_sum
			cd_log_sum=vsn_sum

			#Content Word Index Score Count:
			freq_content_sum=vsn_sum
			cd_content_sum=vsn_sum
			freq_log_content_sum=vsn_sum
			cd_log_content_sum=vsn_sum

			#Function Word Index Score Count:
			freq_functionw_sum=vsn_sum
			cd_functionw_sum=vsn_sum
			freq_log_functionw_sum=vsn_sum
			cd_log_functionw_sum=vsn_sum
	
		#BNC Counts:
			#Every Word Incidence Count:         
			bnc_written_freq_count=vsn_count
			bnc_written_range_count=vsn_count
			bnc_spoken_freq_count=vsn_count
			bnc_spoken_range_count=vsn_count

			#Content Word Incidence Count:
			bnc_written_freq_content_count=vsn_count
			bnc_written_range_content_count=vsn_count
			bnc_spoken_freq_content_count=vsn_count
			bnc_spoken_range_content_count=vsn_count

			#Function Word Incidence Count:
			bnc_written_freq_functionw_count=vsn_count
			bnc_written_range_functionw_count=vsn_count
			bnc_spoken_freq_functionw_count=vsn_count
			bnc_spoken_range_functionw_count=vsn_count

			#Every Word Index Score Count:
			bnc_written_freq_sum=vsn_sum
			bnc_written_freq_log_sum=vsn_sum
			bnc_written_range_sum=vsn_sum
			bnc_spoken_freq_sum=vsn_sum
			bnc_spoken_freq_log_sum=vsn_sum
			bnc_spoken_range_sum=vsn_sum

			#Content Word Index Score Count:
			bnc_written_freq_content_sum=vsn_sum
			bnc_written_freq_log_content_sum=vsn_sum
			bnc_written_range_content_sum=vsn_sum
			bnc_spoken_freq_content_sum=vsn_sum
			bnc_spoken_freq_log_content_sum=vsn_sum
			bnc_spoken_range_content_sum=vsn_sum

			#Function Word Index Score Count:
			bnc_written_freq_functionw_sum=vsn_sum
			bnc_written_freq_log_functionw_sum=vsn_sum
			bnc_written_range_functionw_sum=vsn_sum
			bnc_spoken_freq_functionw_sum=vsn_sum
			bnc_spoken_freq_log_functionw_sum=vsn_sum
			bnc_spoken_range_functionw_sum=vsn_sum
		
		#Brysbaert et al. Concreteness Counts:
			#All words	
			B_uni_count = vsn_count
			B_bi_count = vsn_count
			B_combined_count = vsn_count

			B_uni_sum = vsn_sum
			B_bi_sum = vsn_sum
			B_combined_sum= vsn_sum

			#Content Words  
			B_uni_content_count = vsn_count
			B_combined_content_count = vsn_count

			B_uni_content_sum = vsn_sum
			B_combined_content_sum= vsn_sum

			#Function Words  
			B_uni_funct_count = vsn_count
			B_combined_funct_count = vsn_count

			B_uni_funct_sum = vsn_sum
			B_combined_funct_sum= vsn_sum
		
			for word in text:
			######## This is new in V.09 ###############	
				if len(word)==1 and word in punctuation:
					continue
			##############################################	
				if word[-1] in punctuation:
					word = word[:-1]
			##### This is new in V .06 ###### :
				if word[0] in punctuation:
					word = word[1:]
			#################################
				clean_text.append(word)
			
				#Creates version of text for AFL
				AFL_Text.append(word)
			
			#SUBTLEXus Calculations
				#Every Word Indices:
			
				#The 'float' function is necessary to change the numbers in the text file from
				#a string to a number.
				if word in freq and freq[word] is not '0':
					freq_count+=1
					freq_sum+=float(freq[word])

				if word in cd and cd[word] is not '0':
					cd_count+=1
					cd_sum+=float(cd[word])

				if word in freq_log and freq_log[word] is not '0':
					freq_log_count+=1
					freq_log_sum+=float(freq_log[word])

				if word in cd_log and cd_log[word] is not '0':
					cd_log_count+=1
					cd_log_sum+=float(cd_log[word])

				#Content Word Indices:

				if word in freq and freq[word] is not '0' and word not in stoplist:
					freq_content_count+=1
					freq_content_sum+=float(freq[word])

				if word in cd and cd[word] is not '0' and word not in stoplist:
					cd_content_count+=1
					cd_content_sum+=float(cd[word])

				if word in freq_log and freq_log[word] is not '0' and word not in stoplist:
					freq_log_content_count+=1
					freq_log_content_sum+=float(freq_log[word])

				if word in cd_log and cd_log[word] is not '0' and word not in stoplist:
					cd_log_content_count+=1
					cd_log_content_sum+=float(cd_log[word])

				#Function Word Indices:

				if word in freq and freq[word] is not '0' and word in stoplist:
					freq_functionw_count+=1
					freq_functionw_sum+=float(freq[word])

				if word in cd and cd[word] is not '0' and word in stoplist:
					cd_functionw_count+=1
					cd_functionw_sum+=float(cd[word])

				if word in freq_log and freq_log[word] is not '0' and word in stoplist:
					freq_log_functionw_count+=1
					freq_log_functionw_sum+=float(freq_log[word])

				if word in cd_log and cd_log[word] is not '0' and word in stoplist:
					cd_log_functionw_count+=1
					cd_log_functionw_sum+=float(cd_log[word])

			#BNC Frequency Calculations:
				#Every Word:
				if word in freq_written and freq_written[word] is not '0':
					bnc_written_freq_count+=1
					bnc_written_freq_sum+=float(freq_written[word])
					bnc_written_freq_log_sum+=float(freq_written_log[word])

				if word in range_written and range_written[word] is not '0':
					bnc_written_range_count+=1
					bnc_written_range_sum+=float(range_written[word])
	
				if word in freq_spoken and freq_spoken[word] is not '0':
					bnc_spoken_freq_count+=1
					bnc_spoken_freq_sum+=float(freq_spoken[word])
					bnc_spoken_freq_log_sum+=float(freq_spoken_log[word])

				if word in range_spoken and range_spoken[word] is not '0':
					bnc_spoken_range_count+=1
					bnc_spoken_range_sum+=float(range_spoken[word])

				#Content Word Indices:
				if word in freq_written and freq_written[word] is not '0' and word not in stoplist:
					bnc_written_freq_content_count+=1
					bnc_written_freq_content_sum+=float(freq_written[word])
					bnc_written_freq_log_content_sum+=float(freq_written_log[word])

				if word in range_written and range_written[word] is not '0' and word not in stoplist:
					bnc_written_range_content_count+=1
					bnc_written_range_content_sum+=float(range_written[word])

				if word in freq_spoken and freq_spoken[word] is not '0' and word not in stoplist:
					bnc_spoken_freq_content_count+=1
					bnc_spoken_freq_content_sum+=float(freq_spoken[word])
					bnc_spoken_freq_log_content_sum+=float(freq_spoken_log[word])

				if word in range_spoken and range_spoken[word] is not '0' and word not in stoplist:
					bnc_spoken_range_content_count+=1
					bnc_spoken_range_content_sum+=float(range_spoken[word])

				#Function Word Indices:
				if word in freq_written and freq_written[word] is not '0' and word in stoplist:
					bnc_written_freq_functionw_count+=1
					bnc_written_freq_functionw_sum+=float(freq_written[word])
					bnc_written_freq_log_functionw_sum+=float(freq_written_log[word])

				if word in range_written and range_written[word] is not '0' and word in stoplist:
					bnc_written_range_functionw_count+=1
					bnc_written_range_functionw_sum+=float(range_written[word])

				if word in freq_spoken and freq_spoken[word] is not '0' and word in stoplist:
					bnc_spoken_freq_functionw_count+=1
					bnc_spoken_freq_functionw_sum+=float(freq_spoken[word])
					bnc_spoken_freq_log_functionw_sum+=float(freq_spoken_log[word])

				if word in range_spoken and range_spoken[word] is not '0' and word in stoplist:
					bnc_spoken_range_functionw_count+=1
					bnc_spoken_range_functionw_sum+=float(range_spoken[word])	
							
				#Creates lemmatized text:
			
				if word in lemma_dict:
					lemma_text.append(lemma_dict[word])
				else:
					lemma_text.append(word)


		# Every Word Indices:
			#The 'float' function is necessary to change the numbers in the text file from
			#a string to a number.
			for word in lemma_text:
		
				if word in kf_freq and kf_freq[word] is not '0':
					kf_freq_count+=1
					kf_freq_sum+=float(kf_freq[word])
					kf_freq_log_count+=1
					kf_freq_log_sum+=float(kf_freq_log[word])

				if word in kf_ncats and kf_ncats[word] is not '0':
					kf_ncats_count+=1
					kf_ncats_sum+=float(kf_ncats[word])

				if word in kf_nsamp and kf_nsamp[word] is not '0':
					kf_nsamp_count+=1
					kf_nsamp_sum+=float(kf_nsamp[word])

				if word in tl_freq and tl_freq[word] is not '0':
					tl_freq_count+=1
					tl_freq_sum+=float(tl_freq[word])
					tl_freq_log_count+=1
					tl_freq_log_sum+=float(tl_freq_log[word])
	
				if word in brown_freq and brown_freq[word] is not '0':
					brown_freq_count+=1
					brown_freq_sum+=float(brown_freq[word])
					brown_freq_log_count+=1
					brown_freq_log_sum+=float(brown_freq_log[word])
	
				if word in fam and fam[word] is not '0':
					fam_count+=1
					fam_sum+=float(fam[word])

				if word in concreteness and concreteness[word] is not '0':
					concreteness_count+=1
					concreteness_sum+=float(concreteness[word])

				if word in imageability and imageability[word] is not '0':
					imageability_count+=1
					imageability_sum+=float(imageability[word])

				if word in meaningfulness_colorado and meaningfulness_colorado[word] is not '0':
					meaningfulness_colorado_count+=1
					meaningfulness_colorado_sum+=float(meaningfulness_colorado[word])

		#Content Word Indices:

				if word in kf_freq and kf_freq[word] is not '0' and word not in stoplist:
					kf_freq_content_count+=1
					kf_freq_content_sum+=float(kf_freq[word])
					kf_freq_log_content_count+=1
					kf_freq_log_content_sum+=float(kf_freq_log[word])

				if word in kf_ncats and kf_ncats[word] is not '0' and word not in stoplist:
					kf_ncats_content_count+=1
					kf_ncats_content_sum+=float(kf_ncats[word])

				if word in kf_nsamp and kf_nsamp[word] is not '0' and word not in stoplist:
					kf_nsamp_content_count+=1
					kf_nsamp_content_sum+=float(kf_nsamp[word])

				if word in tl_freq and tl_freq[word] is not '0' and word not in stoplist:
					tl_freq_content_count+=1
					tl_freq_content_sum+=float(tl_freq[word])
					tl_freq_log_content_count+=1
					tl_freq_log_content_sum+=float(tl_freq_log[word])
	
				if word in brown_freq and brown_freq[word] is not '0' and word not in stoplist:
					brown_freq_content_count+=1
					brown_freq_content_sum+=float(brown_freq[word])
					brown_freq_log_content_count+=1
					brown_freq_log_content_sum+=float(brown_freq_log[word])

				if word in fam and fam[word] is not '0' and word not in stoplist:
					fam_content_count+=1
					fam_content_sum+=float(fam[word])

				if word in concreteness and concreteness[word] is not '0' and word not in stoplist:
					concreteness_content_count+=1
					concreteness_content_sum+=float(concreteness[word])

				if word in imageability and imageability[word] is not '0' and word not in stoplist:
					imageability_content_count+=1
					imageability_content_sum+=float(imageability[word])

				if word in meaningfulness_colorado and meaningfulness_colorado[word] is not '0' and word not in stoplist:
					meaningfulness_colorado_content_count+=1
					meaningfulness_colorado_content_sum+=float(meaningfulness_colorado[word])

		#Function Word Indices:

				if word in kf_freq and kf_freq[word] is not '0' and word in stoplist:
					kf_freq_functionw_count+=1
					kf_freq_functionw_sum+=float(kf_freq[word])
					kf_freq_log_functionw_count+=1
					kf_freq_log_functionw_sum+=float(kf_freq_log[word])
	
				if word in kf_ncats and kf_ncats[word] is not '0' and word in stoplist:
					kf_ncats_functionw_count+=1
					kf_ncats_functionw_sum+=float(kf_ncats[word])

				if word in kf_nsamp and kf_nsamp[word] is not '0' and word in stoplist:
					kf_nsamp_functionw_count+=1
					kf_nsamp_functionw_sum+=float(kf_nsamp[word])

				if word in tl_freq and tl_freq[word] is not '0' and word in stoplist:
					tl_freq_functionw_count+=1
					tl_freq_functionw_sum+=float(tl_freq[word])
					tl_freq_log_functionw_count+=1
					tl_freq_log_functionw_sum+=float(tl_freq_log[word])
	
				if word in brown_freq and brown_freq[word] is not '0' and word in stoplist:
					brown_freq_functionw_count+=1
					brown_freq_functionw_sum+=float(brown_freq[word])
					brown_freq_log_functionw_count+=1
					brown_freq_log_functionw_sum+=float(brown_freq_log[word])

				if word in fam and fam[word] is not '0' and word in stoplist:
					fam_functionw_count+=1
					fam_functionw_sum+=float(fam[word])

				if word in concreteness and concreteness[word] is not '0' and word in stoplist:
					concreteness_functionw_count+=1
					concreteness_functionw_sum+=float(concreteness[word])

				if word in imageability and imageability[word] is not '0' and word in stoplist:
					imageability_functionw_count+=1
					imageability_functionw_sum+=float(imageability[word])

				if word in meaningfulness_colorado and meaningfulness_colorado[word] is not '0' and word in stoplist:
					meaningfulness_colorado_functionw_count+=1
					meaningfulness_colorado_functionw_sum+=float(meaningfulness_colorado[word])

				#AWL Counts:

				if word in awl_sl_1: awl_sl_1_count+=1
				if word in awl_sl_2: awl_sl_2_count+=1
				if word in awl_sl_3: awl_sl_3_count+=1
				if word in awl_sl_4: awl_sl_4_count+=1
				if word in awl_sl_5: awl_sl_5_count+=1
				if word in awl_sl_6: awl_sl_6_count+=1
				if word in awl_sl_7: awl_sl_7_count+=1
				if word in awl_sl_8: awl_sl_8_count+=1
				if word in awl_sl_9: awl_sl_9_count+=1
				if word in awl_sl_10: awl_sl_10_count+=1

				#Kuperman et al. AoA Counts
			
				if word in B_AoA and B_AoA[word] is not '0':
					B_AoA_count+=1
					B_AoA_sum+=float(B_AoA[word])

			#Content Word Indices:          
				if word in B_AoA and B_AoA[word] is not '0' and word not in stoplist:
					B_AoA_content_count+=1
					B_AoA_content_sum+=float(B_AoA[word])


			#Function Word indices:         
				if word in B_AoA and B_AoA[word] is not '0' and word in stoplist:
					B_AoA_funct_count+=1
					B_AoA_funct_sum+=float(B_AoA[word])

			#Brysbaert et al. Unigram Concreteness Indices:
				#All Words:
				if word in B_Conc_Uni and B_Conc_Uni[word] is not '0':
					B_uni_count+=1
					B_uni_sum+=float(B_Conc_Uni[word])

				#Uni-Content Words:
				if word in B_Conc_Uni and B_Conc_Uni[word] is not '0' and word not in stoplist:
					B_uni_content_count+=1
					B_uni_content_sum+=float(B_Conc_Uni[word])
	
				#Uni-Function Words:
				if word in B_Conc_Uni and B_Conc_Uni[word] is not '0' and word in stoplist:
					B_uni_funct_count+=1
					B_uni_funct_sum+=float(B_Conc_Uni[word])	
		
		# AFL:
			AFL_Text = " ".join(str(x) for x in AFL_Text)

			#This adds a space to the beginning and end of AFL_Text to ensure regular expressions will match
			AFL_Text = " " + AFL_Text + " "

			#this uses the function unique_ngrams to get ngram counts for each list	
			afl_all_count = unique_ngrams(AFL_Text, afl_all)
			afl_core_count= unique_ngrams(AFL_Text, afl_core)
			afl_spoken_count = unique_ngrams(AFL_Text, afl_spoken)
			afl_written_count = unique_ngrams(AFL_Text, afl_written)

			#This creates normed scores for each:
			afl_all_count_norm = afl_all_count/nwords2
			afl_core_count_norm = afl_core_count/nwords2
			afl_spoken_count_norm = afl_spoken_count/nwords2
			afl_written_count_norm = afl_written_count/nwords2

		#Brysbaert et al Concreteness bigrams and combined:
			#Now we calculate bigram scores and combined scores.  We start with bigram scores so
			#we don't overcount:

			#turns clean text into a string so regular expressions will work:
			clean_text = " ".join(str(x) for x in clean_text)

			#adds space at beginning and end of text to ensure regular expressions will work:
			clean_text = " " + clean_text + " "

			for key in B_Conc_Bi:
				key1 = " " + key + " "
				if len(re.findall(key1, clean_text))>0:
					B_bi_count+=len(re.findall(key1, clean_text))
					#calculates the meaningfullness score sum of key in text:
					B_bi_sum += float(B_Conc_Bi[key]) * len(re.findall(key1, clean_text))
					clean_text = re.sub(key1, " <removed> ", clean_text)	

		#Bigram Average:
			B_bi_average = B_bi_sum/B_bi_count

		#Creates structure for new lemma_text (with bigrams removed)
			lemma_text2 = []

			#Splits text with bigrams removed
			clean_text2 = clean_text.split()

			for word in clean_text2:
				if word in lemma_dict:
					lemma_text2.append(lemma_dict[word])
				else:
					lemma_text2.append(word)

			#for combined scores, initially set combined counts/sums to Bi counts/sums
			B_combined_count = B_bi_count
			B_combined_content_count = B_bi_count
			B_combined_funct_count = B_bi_count

			B_combined_sum = B_bi_sum
			B_combined_content_sum = B_bi_sum
			B_combined_funct_sum = B_bi_sum


			for word in lemma_text2:
			#Uni-All Words for Combined:
				if word in B_Conc_Uni and B_Conc_Uni[word] is not '0':
					B_combined_count+=1
					B_combined_sum+=float(B_Conc_Uni[word])

			#Uni-Content Words for combined:
				if word in B_Conc_Uni and B_Conc_Uni[word] is not '0' and word not in stoplist:
					B_combined_content_count+=1
					B_combined_content_sum+=float(B_Conc_Uni[word])

			#Uni-Function Words for combined:
				if word in B_Conc_Uni and B_Conc_Uni[word] is not '0' and word in stoplist:
					B_combined_funct_count+=1
					B_combined_funct_sum+=float(B_Conc_Uni[word])

		# Begin BNC N-Gram Indices:
			NG_text= file(filename, 'rU').read()
			#print NG_text
			NG_clean_text = re.sub(r'\.|\?|\,|\!|\;|\:', '', NG_text)#removes punctuation
			NG_text1 = NG_clean_text.lower().split()#lowers and splits
			Text = [] #new list
			for word in NG_text1:
				Text.append(word)#puts all the words in a list
			#print Text

			word_count = 0#starts word count

			#creates holder structure for bigrams and trigrams
			bigrams = []
			trigrams = []

			#creates holder structure for proportions 
			unique_bigrams_spoken = []
			unique_bigrams_written = []
			unique_trigrams_spoken = []
			unique_trigrams_written = []

			#creates bigram and trigram counter
			bigram_counter = 0
			trigram_counter = 0

			#create bigram version of Text:	
			for word in Text:
					word_count += 1 #word count
					pre_bigram = Text[bigram_counter:(bigram_counter+2)]
					bigrams.append(" ".join(str(x) for x in pre_bigram))
					bigram_counter+=1


			for word in Text:
				pre_trigram = Text[trigram_counter:(trigram_counter+3)]
				trigrams.append(" ".join(str(x) for x in pre_trigram))
				trigram_counter+=1
			#print trigrams
			#print word_count


		#bigram and trigram incidence count
			bigram_spoke_freq_count = vsn_count
			bigram_written_freq_count = vsn_count
			trigram_spoke_freq_count = vsn_count
			trigram_written_freq_count = vsn_count

		#bigram and trigram index score count
			bigram_spoke_freq_sum = vsn_count
			bigram_written_freq_sum = vsn_count
			trigram_spoke_freq_sum = vsn_count
			trigram_written_freq_sum = vsn_count

			bigram_spoke_freq_log_sum = vsn_count
			bigram_written_freq_log_sum = vsn_count
			trigram_spoke_freq_log_sum = vsn_count
			trigram_written_freq_log_sum = vsn_count

		#bigram and trigram indices
			for bigram in bigrams:
				#print bigrams
				bigramset = set(bigrams)
				bigram_type_count = len(bigramset)-1#this counts a bigram type score - 1 to 
				#because final word is counted as bigram even though it is a unigram

				if bigram in spoken_bi:
					bigram_spoke_freq_count+=1
					bigram_spoke_freq_sum+=float(spoken_bi[bigram])
					bigram_spoke_freq_log_sum+=float(spoken_bi_log[bigram])
					unique_bigrams_spoken.append(bigram) #appends all bigrams found in reference
					#list and in text to a new list
					#print unique_bigrams_spoken
					unique_bigrams_spoken_set = set(unique_bigrams_spoken)#finds unique bigrams in list
					#print unique_bigrams_set
					proportion_unique_spoken_bigrams = len(unique_bigrams_spoken_set)/word_count
					#counts them giving proportion score

				if bigram in written_bi:
					bigram_written_freq_count+=1
					bigram_written_freq_sum+=float(written_bi[bigram])
					bigram_written_freq_log_sum+=float(written_bi_log[bigram])
					unique_bigrams_written.append(bigram) #appends all bigrams found in reference
					#list and in text to a new list
					unique_bigrams_written_set = set(unique_bigrams_written)#finds unique bigrams in list
					proportion_unique_written_bigrams = len(unique_bigrams_written_set)/word_count

			#New 3/30/14
			if unique_bigrams_spoken == []:
				proportion_unique_spoken_bigrams = "N/A"
			if unique_bigrams_written == []:
				proportion_unique_written_bigrams = "N/A"
			
			for trigram in trigrams:
				trigramset = set(trigrams)
				trigram_type_count = len(trigramset)-2#this counts a trigram type score -2 to 
				#because final two words counted as trigrams even though they are unigrams

				if trigram in spoken_tri:
					trigram_spoke_freq_count+=1
					trigram_spoke_freq_sum+=float(spoken_tri[trigram])
					trigram_spoke_freq_log_sum+=float(spoken_tri_log[trigram])
					unique_trigrams_spoken.append(trigram) #appends all bigrams found in reference
					#list and in text to a new list
					unique_trigrams_spoken_set = set(unique_trigrams_spoken)#finds unique bigrams in list
					proportion_unique_spoken_trigrams = len(unique_trigrams_spoken_set)/word_count
					#counts them giving proportion score


				if trigram in written_tri:
					trigram_written_freq_count+=1
					trigram_written_freq_sum+=float(written_tri[trigram])
					trigram_written_freq_log_sum+=float(written_tri_log[trigram])
					unique_trigrams_written.append(trigram) #appends all bigrams found in reference
					#list and in text to a new list
					unique_trigrams_written_set = set(unique_trigrams_written)#finds unique bigrams in list
					proportion_unique_written_trigrams = len(unique_trigrams_written_set)/word_count
		
			#New 3/30/14
			if unique_trigrams_spoken == []:
				proportion_unique_spoken_trigrams = "N/A"
			if unique_trigrams_written == []:
				proportion_unique_written_trigrams = "N/A"
		
			#End The Craziness that is the BNC N-gram Calculator
		
			#AWL indices:
			nwords = len(lemma_text)

			awl_sl_1_index = awl_sl_1_count/nwords
			awl_sl_2_index = awl_sl_2_count/nwords
			awl_sl_3_index = awl_sl_3_count/nwords
			awl_sl_4_index = awl_sl_4_count/nwords
			awl_sl_5_index = awl_sl_5_count/nwords
			awl_sl_6_index = awl_sl_6_count/nwords
			awl_sl_7_index = awl_sl_7_count/nwords
			awl_sl_8_index = awl_sl_8_count/nwords
			awl_sl_9_index = awl_sl_9_count/nwords
			awl_sl_10_index = awl_sl_10_count/nwords

			all_awl_count = awl_sl_1_count + awl_sl_2_count + awl_sl_3_count + awl_sl_4_count + awl_sl_5_count + awl_sl_6_count + awl_sl_7_count + awl_sl_8_count + awl_sl_9_count +awl_sl_10_count
			all_awl_index = all_awl_count/nwords
		
	#Every Word Mean Score (Total Index Score/Number of Incidences):
	

			kf_freq_average=kf_freq_sum/kf_freq_count
			kf_freq_log_average=kf_freq_log_sum/kf_freq_log_count
			kf_ncats_average=kf_ncats_sum/kf_ncats_count
			kf_nsamp_average=kf_nsamp_sum/kf_nsamp_count
			tl_freq_average=tl_freq_sum/tl_freq_count
			tl_freq_log_average=tl_freq_log_sum/tl_freq_log_count
			brown_freq_average=brown_freq_sum/brown_freq_count
			brown_freq_log_average=brown_freq_log_sum/brown_freq_log_count
			fam_average=fam_sum/fam_count
			concreteness_average=concreteness_sum/concreteness_count
			imageability_average=imageability_sum/imageability_count
			meaningfulness_colorado_average=meaningfulness_colorado_sum/meaningfulness_colorado_count

		#Content Word Mean Score (Total Content Word Index Score/Number of Content Words):

			kf_freq_content_average=kf_freq_content_sum/kf_freq_content_count
			kf_freq_log_content_average=kf_freq_log_content_sum/kf_freq_log_content_count
			kf_ncats_content_average=kf_ncats_content_sum/kf_ncats_content_count
			kf_nsamp_content_average=kf_nsamp_content_sum/kf_nsamp_content_count
			tl_freq_content_average=tl_freq_content_sum/tl_freq_content_count
			tl_freq_log_content_average=tl_freq_log_content_sum/tl_freq_log_content_count
			brown_freq_content_average=brown_freq_content_sum/brown_freq_content_count
			brown_freq_log_content_average=brown_freq_log_content_sum/brown_freq_log_content_count
			fam_content_average=fam_content_sum/fam_content_count
			concreteness_content_average=concreteness_content_sum/concreteness_content_count
			imageability_content_average=imageability_content_sum/imageability_content_count
			meaningfulness_colorado_content_average=meaningfulness_colorado_content_sum/meaningfulness_colorado_content_count

		#Function Word Mean Score (Total Function Word Index Score/Number of Function Words):
			kf_freq_functionw_average=kf_freq_functionw_sum/kf_freq_functionw_count
			kf_freq_log_functionw_average=kf_freq_log_functionw_sum/kf_freq_log_functionw_count
			kf_ncats_functionw_average=kf_ncats_functionw_sum/kf_ncats_functionw_count
			kf_nsamp_functionw_average=kf_nsamp_functionw_sum/kf_nsamp_functionw_count
			tl_freq_functionw_average=tl_freq_functionw_sum/tl_freq_functionw_count
			tl_freq_log_functionw_average=tl_freq_log_functionw_sum/tl_freq_log_functionw_count
			brown_freq_functionw_average=brown_freq_functionw_sum/brown_freq_functionw_count
			brown_freq_log_functionw_average=brown_freq_log_functionw_sum/brown_freq_log_functionw_count
			fam_functionw_average=fam_functionw_sum/fam_functionw_count
			concreteness_functionw_average=concreteness_functionw_sum/concreteness_functionw_count
			imageability_functionw_average=imageability_functionw_sum/imageability_functionw_count
			meaningfulness_colorado_functionw_average=meaningfulness_colorado_functionw_sum/meaningfulness_colorado_functionw_count

			# Kuperman et al. AoA Mean Scores:       
			B_AoA_average=B_AoA_sum/B_AoA_count
			B_AoA_content_average=B_AoA_content_sum/B_AoA_content_count
			B_AoA_funct_average=B_AoA_funct_sum/B_AoA_funct_count	

			# Kuperman et al. AoA Log Scores:

			if B_AoA_average == 0.0:
				B_AoA_average_log = 0
			else:B_AoA_average_log = math.log10(B_AoA_average)

			if B_AoA_content_average == 0.0:
				B_AoA_content_average_log = 0
			else:B_AoA_content_average_log = math.log10(B_AoA_content_average) 

			if B_AoA_funct_average == 0.0:
				B_AoA_funct_average_log= 0
			else:B_AoA_funct_average_log = math.log10(B_AoA_funct_average)	

		#SUBTLEXus Scores:
			#Every Word Mean Score (Total Index Score/Number of Incidences):
			freq_average=freq_sum/freq_count
			cd_average=cd_sum/cd_count
			freq_log_average=freq_log_sum/freq_log_count
			cd_log_average=cd_log_sum/cd_log_count

			#Content Word Mean Score (Total Content Word Index Score/Number of Content Words):

			freq_content_average=freq_content_sum/freq_content_count
			cd_content_average=cd_content_sum/cd_content_count
			freq_log_content_average=freq_log_content_sum/freq_log_content_count
			cd_log_content_average=cd_log_content_sum/cd_log_content_count

			#Function Word Mean Score (Total Function Word Index Score/Number of Function Words):
			freq_functionw_average=freq_functionw_sum/freq_functionw_count
			cd_functionw_average=cd_functionw_sum/cd_functionw_count
			freq_log_functionw_average=freq_log_functionw_sum/freq_log_functionw_count
			cd_log_functionw_average=cd_log_functionw_sum/cd_log_functionw_count

		#BNC Frequencies	
			#Every Word Mean Score (Total Index Score/Number of Incidences):
			bnc_written_freq_average=bnc_written_freq_sum/bnc_written_freq_count
			bnc_written_freq_average_log=bnc_written_freq_log_sum/bnc_written_freq_count
			bnc_written_range_average=bnc_written_range_sum/bnc_written_range_count
			bnc_spoken_freq_average=bnc_spoken_freq_sum/bnc_spoken_freq_count
			bnc_spoken_freq_average_log=bnc_spoken_freq_log_sum/bnc_spoken_freq_count
			bnc_spoken_range_average=bnc_spoken_range_sum/bnc_spoken_range_count

			#Content Word Mean Score (Total Content Word Index Score/Number of Content Words):
			bnc_written_freq_content_average=bnc_written_freq_content_sum/bnc_written_freq_content_count
			bnc_written_freq_content_average_log=bnc_written_freq_log_content_sum/bnc_written_freq_content_count
			bnc_written_range_content_average=bnc_written_range_content_sum/bnc_written_range_content_count
			bnc_spoken_freq_content_average=bnc_spoken_freq_content_sum/bnc_spoken_freq_content_count
			bnc_spoken_freq_content_average_log=bnc_spoken_freq_log_content_sum/bnc_spoken_freq_content_count
			bnc_spoken_range_content_average=bnc_spoken_range_content_sum/bnc_spoken_range_content_count

			#Function Word Mean Score (Total Function Word Index Score/Number of Function Words):
			bnc_written_freq_functionw_average=bnc_written_freq_functionw_sum/bnc_written_freq_functionw_count
			bnc_written_freq_functionw_average_log=bnc_written_freq_log_functionw_sum/bnc_written_freq_functionw_count
			bnc_written_range_functionw_average=bnc_written_range_functionw_sum/bnc_written_range_functionw_count
			bnc_spoken_freq_functionw_average=bnc_spoken_freq_functionw_sum/bnc_spoken_freq_functionw_count
			bnc_spoken_freq_functionw_average_log=bnc_spoken_freq_log_functionw_sum/bnc_spoken_freq_functionw_count
			bnc_spoken_range_functionw_average=bnc_spoken_range_functionw_sum/bnc_spoken_range_functionw_count

		#Brysbaert et al Unigram Concreteness:
			B_uni_average=B_uni_sum/B_uni_count
			B_uni_content_average= B_uni_content_sum/B_uni_content_count
			B_uni_funct_average= B_uni_funct_sum/B_uni_funct_count	
	
		#Brysbaert et al. Combined:
			B_combined_all_average = B_combined_sum/B_combined_count
			B_combined_content_average = B_combined_content_sum/B_combined_content_count
			B_combined_funct_average = B_combined_funct_sum/B_combined_funct_count	
		
		#BNC N-gram Counts:
			norm_spoken_bi_bi = bigram_spoke_freq_sum/bigram_spoke_freq_count #normed by bigram
			norm_spoken_bi_bi_log = bigram_spoke_freq_log_sum/bigram_spoke_freq_count

			norm_spoken_bi_word = bigram_spoke_freq_sum/word_count
			norm_spoken_bi_word_log= bigram_spoke_freq_log_sum/word_count

			norm_written_bi_bi = bigram_written_freq_sum/bigram_written_freq_count #normed by bigram
			norm_written_bi_bi_log = bigram_written_freq_log_sum/bigram_written_freq_count

			norm_written_bi_word = bigram_written_freq_sum/word_count
			norm_written_bi_word_log = bigram_written_freq_log_sum/word_count

			norm_spoken_tri_tri = trigram_spoke_freq_sum/trigram_spoke_freq_count #normed by trigram
			norm_spoken_tri_tri_log = trigram_spoke_freq_log_sum/trigram_spoke_freq_count

			norm_spoken_tri_word = trigram_spoke_freq_sum/word_count
			norm_spoken_tri_word_log = trigram_spoke_freq_log_sum/word_count

			norm_written_tri_tri = trigram_written_freq_sum/trigram_written_freq_count
			norm_written_tri_tri_log = trigram_written_freq_log_sum/trigram_written_freq_count

			norm_written_tri_word = trigram_written_freq_sum/word_count
			norm_written_tri_word_log = trigram_written_freq_log_sum/word_count
				
			outf.write ('{0}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {22}, {23}, {24}, {25}, {26}, {27}, {28}, {29}, {30}, {31}, {32}, {33}, {34}, {35}, {36}, {37}, {38}, {39}, {40}, {41}, {42}, {43}, {44}, {45}, {46}, {47}, {48}, {49}, {50}, {51}, {52}, {53}, {54}, {55}, {56}, {57}, {58}, {59}, {60}, {61}, {62}, {63}, {64}, {65}, {66}, {67}, {68}, {69}, {70}, {71}, {72}, {73}, {74}, {75}, {76}, {77}, {78}, {79}, {80}, {81}, {82}, {83}, {84}, {85}, {86}, {87}, {88}, {89}, {90},{91}, {92}, {93}, {94}, {95}, {96}, {97}, {98}, {99}, {100},{101}, {102}, {103}, {104}, {105}, {106}, {107}, {108}, {109}, {110}, {111}, {112}, {113}, {114}, {115}, {116}, {117}, {118}, {119}, {120}, {121}, {122}, {123}, {124}, {125}, {126}, {127}, {128}, {129}, {130}, {131}, {132}, {133}, {134}, {135}, {136}, {137}\n'
			.format(filename,nwords,bnc_written_freq_average,bnc_written_freq_average_log,bnc_written_freq_content_average,bnc_written_freq_content_average_log,bnc_written_freq_functionw_average,bnc_written_freq_functionw_average_log,bnc_spoken_freq_average,bnc_spoken_freq_average_log,bnc_spoken_freq_content_average,bnc_spoken_freq_content_average_log,bnc_spoken_freq_functionw_average,bnc_spoken_freq_functionw_average_log,brown_freq_average,brown_freq_log_average,brown_freq_content_average,brown_freq_log_content_average,brown_freq_functionw_average,brown_freq_log_functionw_average,kf_freq_average,kf_freq_log_average,kf_freq_content_average,kf_freq_log_content_average,kf_freq_functionw_average,kf_freq_log_functionw_average,freq_average,freq_log_average,freq_content_average,freq_log_content_average,freq_functionw_average,freq_log_functionw_average,tl_freq_average,tl_freq_log_average,tl_freq_content_average,tl_freq_log_content_average,tl_freq_functionw_average,tl_freq_log_functionw_average,bnc_written_range_average,bnc_written_range_content_average,bnc_written_range_functionw_average,bnc_spoken_range_average,bnc_spoken_range_content_average,bnc_spoken_range_functionw_average,kf_ncats_average,kf_ncats_content_average,kf_ncats_functionw_average,kf_nsamp_average,kf_nsamp_content_average,kf_nsamp_functionw_average,cd_average,cd_log_average,cd_content_average,cd_log_content_average,cd_functionw_average,cd_log_functionw_average,word_count,bigram_type_count,trigram_type_count,bigram_written_freq_log_sum,norm_written_bi_bi,norm_written_bi_bi_log,norm_written_bi_word,norm_written_bi_word_log,trigram_written_freq_log_sum,norm_written_tri_tri,norm_written_tri_tri_log,norm_written_tri_word,norm_written_tri_word_log,bigram_spoke_freq_log_sum,norm_spoken_bi_bi,norm_spoken_bi_bi_log,norm_spoken_bi_word,norm_spoken_bi_word_log,trigram_spoke_freq_log_sum,norm_spoken_tri_tri,norm_spoken_tri_tri_log,norm_spoken_tri_word,norm_spoken_tri_word_log,proportion_unique_written_bigrams,proportion_unique_spoken_bigrams,proportion_unique_written_trigrams,proportion_unique_spoken_trigrams,afl_all_count,afl_all_count_norm,afl_core_count,afl_core_count_norm,afl_spoken_count,afl_spoken_count_norm,afl_written_count,afl_written_count_norm,all_awl_count,all_awl_index,awl_sl_1_count,awl_sl_1_index,awl_sl_2_count,awl_sl_2_index,awl_sl_3_count,awl_sl_3_index,awl_sl_4_count,awl_sl_4_index,awl_sl_5_count,awl_sl_5_index,awl_sl_6_count,awl_sl_6_index,awl_sl_7_count,awl_sl_7_index,awl_sl_8_count,awl_sl_8_index,awl_sl_9_count,awl_sl_9_index,awl_sl_10_count,awl_sl_10_index,B_AoA_average,B_AoA_average_log,B_AoA_content_average,B_AoA_content_average_log,B_AoA_funct_average,B_AoA_funct_average_log,B_uni_average,B_uni_content_average,B_uni_funct_average,B_bi_average,B_combined_all_average,B_combined_content_average,B_combined_funct_average,concreteness_average,concreteness_content_average,concreteness_functionw_average,fam_average,fam_content_average,fam_functionw_average,imageability_average,imageability_content_average,imageability_functionw_average,meaningfulness_colorado_average,meaningfulness_colorado_content_average,meaningfulness_colorado_functionw_average))

		outf.flush()#flushes out buffer to clean output file
		outf.close()#close output file  

		#Closing Message to let user know that the program did something: (may need to be more sophisticated)	
		nfiles = len(filenames)
		finishmessage = ("Processed " + str(nfiles) + " Files")
		dataQueue.put(finishmessage)
		root.update_idletasks()
		#self.progress.config(text =finishmessage)
		tkMessageBox.showinfo("Finished!", "Your files have been processed by TAALES!")

class Catcher:
    def __init__(self, func, subst, widget):
        self.func = func
        self.subst = subst
        self.widget = widget

    def __call__(self, *args):
        try:
            if self.subst:
                args = apply(self.subst, args)
            return apply(self.func, args)
        except SystemExit, msg:
            raise SystemExit, msg
        except:
            import traceback
            import tkMessageBox
            ermessage = traceback.format_exc(1)
            ermessage = re.sub(r'.*(?=Error)', "", ermessage, flags=re.DOTALL)
            ermessage = "There was a problem processing your files:\n\n"+ermessage
            tkMessageBox.showerror("Error Message", ermessage)

if __name__ == '__main__':		
	root = tk.Tk()
	root.wm_title("TAALES Version 1.3")
	root.configure(background = '#BFEAA3')
	#sets starting size: NOTE: it doesn't appear as though Tkinter will let you make the 
	#starting size smaller than the space needed for widgets.
	root.geometry("450x650")
	tk.CallWrapper = Catcher
	myapp = MyApp(root)
	root.mainloop()

